#pragma once

class DXFrame
{
protected:
	IDirect3DDevice9*	_device;

private:
	WCHAR _windowTitle[80];
	int _width;
	int _height;
	bool _windowed;

public:
	DXFrame(const WCHAR *windowTitle = L"DXProject", int width = 800, int height = 600, bool windowed = true)
		: _width(width), _height(height), _windowed(windowed)
	{
		wcscpy_s(_windowTitle, windowTitle);
	}

	virtual ~DXFrame(void) {}

//--------Tulterheto/tulterhelendo fuggvenyek-------------------------------------

	// Create any D3DPOOL_MANAGED resources here 
	virtual HRESULT onCreateDevice() { return S_OK; }

	// Create any D3DPOOL_DEFAULT resources here 
	virtual HRESULT onResetDevice() { return S_OK; }

	// Release resources created in the OnResetDevice callback here 
	virtual void onLostDevice()	{}

	// Release resources created in the OnCreateDevice callback here
	virtual void onDestroyDevice() {}

	// Handle updates to the scene
	virtual void onFrameMove( double fTime, float fElapsedTime ) {}

	// Render the scene 
	virtual void onFrameRender( double fTime, float fElapsedTime ) {}

	// Handle messages to the application 
	virtual LRESULT msgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, bool* pbNoFurtherProcessing ) { return 0; }

	// Handle keyboard events
	virtual void keyboardProc( UINT nChar, bool bKeyDown, bool bAltDown ) {}

	// Handle mouse events
	virtual void mouseProc(bool bLeftButtonDown, bool bRightButtonDown, bool bMiddleButtonDown,
				   bool bSideButton1Down, bool bSideButton2Down, INT nMouseWheelDelta,
				   INT xPos, INT yPos ) {}

//--------Esemenykezelo fuggvenyek------------------------------------------------
	HRESULT __onCreateDevice(IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc)
	{
		_device = pd3dDevice;

		return onCreateDevice();
	}

	HRESULT __onResetDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc)
	{
		_width = pBackBufferSurfaceDesc->Width;
		_height = pBackBufferSurfaceDesc->Height;
		return onResetDevice();
	}


//--------Kiegeszito fuggvenyek---------------------------------------------------
	const WCHAR * getWindowTitle() const { return _windowTitle; }
	int getWidth() const { return _width; }
	int getHeight() const { return _height; }
	bool isWindowed() const { return _windowed; }

protected:
	void terminate()
	{
		HWND hWnd = DXUTGetHWND();
		if( hWnd != NULL )
			SendMessage( hWnd, WM_CLOSE, 0, 0 );
	}
};
