#pragma once
#include "dxframe.hpp"

class Lights :
	public DXFrame
{
public:
	Lights(void);
	~Lights(void);
	HRESULT onCreateDevice();
	HRESULT onResetDevice();
	void onDestroyDevice();
	void onFrameMove( double fTime, float fElapsedTime );
	void onFrameRender( double fTime, float fElapsedTime );
	void keyboardProc( UINT nChar, bool bKeyDown, bool bAltDown );
	void mouseProc(bool bLeftButtonDown, bool bRightButtonDown, bool bMiddleButtonDown,
				   bool bSideButton1Down, bool bSideButton2Down, INT nMouseWheelDelta,
				   INT xPos, INT yPos );

protected:
	void setWorldViewMatrix();

	// FVF ler:
	enum {FVF = D3DFVF_XYZ | D3DFVF_NORMAL};

	// FVF struktra
	struct VERTEXFORMAT
	{
		D3DXVECTOR3 v;
		D3DXVECTOR3 n; // feluleti normalis
	};

	// Vertex Buffer
	IDirect3DVertexBuffer9* _vbuffer;
	// Index Buffer
	IDirect3DIndexBuffer9* _ibuffer;
	float yaw, pitch;
	bool wireframe;
	D3DXMATRIX world;
};

